<template lang="pug">
  centered
    Spinner(v-if="checking" text="checking activation token…")
    div(v-else)
      .empty(v-if="error")
        .empty(v-show="resend")
          .empty-icon
            <z-icon tabindex="-1" name="markunread_mailbox" />
          p.empty-title.h5 {{ $t('enter account email') }}
          p.empty-subtitle {{ $t('enter account email help') }}
          .empty-action.input-group
            .form-group
              input.form-input(ref="email" type="text" :placeholder="$t('email')" v-model="email" v-validate="'email'" data-vv-as="email" name="email")
            //- TODO: make new activation link backend
            z-button.input-group-btn(color="primary") {{ $t('account activate send link') }}
        
        .empty(v-show="!resend")
          .empty-icon
            <z-icon tabindex="-1" name="mood_bad" />
          p.empty-title.h5 {{ $t('account activate error') }}
          p.empty-subtitle {{ $t('account activate error help') }}
          .empty-action
            z-button(color="primary" @click="toggleResend()") {{ $t('account activate send link') }}

      .empty(v-else)
        div.empty-icon
          <z-icon tabindex="-1" name="mood_good" />
        p.empty-title.h5 {{ $t('account activate success') }}
        p.empty-subtitle {{ $t('account activate success help') }}
        .empty-action
          nuxt-link(tabindex="-1" :to="{ path: localePath('about'), query: { to: 'login' } }")
            button.btn.btn-primary {{ $t('login account') }}
</template>

<script>
import Centered from '~/components/sublayouts/Centered.vue'
import Spinner from '~/components/Spinner.vue'

export default {
  components: {
    // layout components:
    Centered,
    // cosmetic components:
    Spinner
  },
  data() {
    return {
      checking: true,
      error: false,
      reason: '',
      resend: false,
      email: ''
    }
  },
  mounted() {
    const query = this.$route.query

    if ('resend' in query) {
      this.checking = false
      this.resend = true
    } else {
      this.checkActivationLink(query)
    }
  },
  methods: {
    async checkActivationLink(query) {
      try {
        const isUid = 'uid' in query
        const isToken = 'token' in query

        if (!(isUid && isToken)) {
          // we don't have proper GET parameters, so showing a generic
          // error is the least we can do.
          this.checking = false
          this.error = true
        } else {
          // we have proper GET parameters, but we still need to check
          // their validity.
          const res = await this.$store.dispatch('auth/activate', {
            token: query.token,
            uid: query.uid
          })
          console.log(res)
          this.checking = false
          if (!res.success) {
            this.reason = res.errors[0]
            this.error = true
          }
        }
      } catch (e) {
        console.error(e)
      }
    },
    toggleResend() {
      this.resend = true
      this.$nextTick(() => this.$refs.email.focus())
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style scoped>
i {
  font-size: 60px;
  max-width: 60px;
}

.input-group {
  justify-content: center;
}

input {
  width: 100% !important;
}
</style>
